searchData={"items":[{"type":"module","title":"OffBroadwayMemory.Buffer","doc":"An in-memory buffer implementation using `:queue`.","ref":"OffBroadwayMemory.Buffer.html"},{"type":"function","title":"OffBroadwayMemory.Buffer.async_push/2","doc":"Push messages to the buffer asynchronously.","ref":"OffBroadwayMemory.Buffer.html#async_push/2"},{"type":"function","title":"OffBroadwayMemory.Buffer.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"OffBroadwayMemory.Buffer.html#child_spec/1"},{"type":"function","title":"OffBroadwayMemory.Buffer.clear/1","doc":"Clear all messages from the buffer.","ref":"OffBroadwayMemory.Buffer.html#clear/1"},{"type":"function","title":"OffBroadwayMemory.Buffer.length/1","doc":"Get the length of the buffer.","ref":"OffBroadwayMemory.Buffer.html#length/1"},{"type":"function","title":"OffBroadwayMemory.Buffer.pop/2","doc":"Pop messages from the buffer.","ref":"OffBroadwayMemory.Buffer.html#pop/2"},{"type":"function","title":"OffBroadwayMemory.Buffer.push/2","doc":"Push messages to the buffer.","ref":"OffBroadwayMemory.Buffer.html#push/2"},{"type":"module","title":"OffBroadwayMemory.Producer","doc":"A Broadway producer for `OffBroadwayMemory.Buffer`.","ref":"OffBroadwayMemory.Producer.html"},{"type":"module","title":"Options - OffBroadwayMemory.Producer","doc":"* `:buffer` - The buffer responsible for storing the queued messages. The buffer can\n  be supervised independently or by Broadway's supervision tree. To\n  supervise the buffer independently, start it before starting Broadway.\n\n* `:resolve_pending_timeout` (`t:non_neg_integer/0`) - The duration (in milliseconds) of the timeout period observed between\n  attempts to resolve any pending demand. The default value is `100`.\n\n* `:on_failure` (`t:atom/0`) - The action to perform on failed messages. Options are `:requeue` and\n  `:discard`. This can also be configured on a per-message basis with\n  `Broadway.Message.configure_ack/2`. The default value is `:requeue`.\n\n* `:buffer_pid` (`t:pid/0`) - *This option is deprecated. Renamed to `buffer` in v1.1.0.* The buffer responsible for storing the queued messages.","ref":"OffBroadwayMemory.Producer.html#module-options"},{"type":"module","title":"Basic Usage - OffBroadwayMemory.Producer","doc":"```\n# Start Broadway:\nBroadway.start_link(MyBroadway,\n  name: MyBroadway,\n  producer: [\n    module: {OffBroadwayMemory.Producer, buffer: :example_buffer},\n    concurrency: 1\n  ],\n  processors: [default: [concurrency: 50]]\n)\n\n# Push data to be processed:\nOffBroadwayMemory.Buffer.push(:example_buffer, [\"example\", \"data\", \"set\"])\n```","ref":"OffBroadwayMemory.Producer.html#module-basic-usage"},{"type":"module","title":"Advanced Usage - OffBroadwayMemory.Producer","doc":"```\n# Start the buffer:\nOffBroadwayMemory.Buffer.start_link(name: :example_buffer)\n\n# Connect it to Broadway:\nBroadway.start_link(MyBroadway,\n  name: MyBroadway,\n  producer: [\n    module: {OffBroadwayMemory.Producer, buffer: :example_buffer},\n    concurrency: 1\n  ],\n  processors: [default: [concurrency: 50]]\n)\n\n# Push data to be processed:\nOffBroadwayMemory.Buffer.push(:example_buffer, [\"example\", \"data\", \"set\"])\n```","ref":"OffBroadwayMemory.Producer.html#module-advanced-usage"},{"type":"module","title":"Telemetry - OffBroadwayMemory.Producer","doc":"This library exposes the following Telemetry events:\n\n* `[:off_broadway_memory, :receive_messages, :start]` - Emitted before receiving messages from the buffer\n\n    * Measurement:\n\n    ```\n    %{\n      # The current system time in native units from\n      # calling: erlang:system_time()\n      system_time => integer(),\n      monotonic_time => integer(),\n    }\n    ```\n\n    * Metadata:\n\n    ```\n    %{\n      name: atom(),\n      demand: integer()\n    }\n    ```\n\n* `[:off_broadway_memory, :receive_messages, :stop]` - Emitted after messages have been received from the buffer and wrapped\n\n    * Mesurement:\n\n    ```\n    %{\n      # The current monotonic time minus the start monotonic time in native units\n      # by calling: erlang:monotonic_time() - start_monotonic_time\n      duration => integer(),\n      monotonic_time => integer()\n    }\n    ```\n\n    * Metadata:\n\n    ```\n    %{\n      name: atom(),\n      messages: [Broadway.Message.t()],\n      demand: integer()\n    }\n    ```","ref":"OffBroadwayMemory.Producer.html#module-telemetry"}],"producer":{"name":"ex_doc","version":[48,46,51,52,46,49]},"content_type":"text/markdown"}